<?php

namespace Lc\CaracoleBundle\Controller\Config;

use EasyCorp\Bundle\EasyAdminBundle\Config\Crud;
use EasyCorp\Bundle\EasyAdminBundle\Field\IntegerField;
use EasyCorp\Bundle\EasyAdminBundle\Field\NumberField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use Lc\CaracoleBundle\Controller\AdminControllerTrait;
use Lc\SovBundle\Controller\AbstractAdminController;

abstract class TaxRateAdminController extends AbstractAdminController
{
    use AdminControllerTrait;

    public function configureCrud(Crud $crud): Crud
    {
        return $crud->setSearchFields(['id', 'title', 'value']);
    }

    public function configureFields(string $pageName): iterable
    {
        return [
                IntegerField::new('id', 'ID')->hideOnForm(),
                TextField::new('title'),
                NumberField::new('value')
        ];
    }
}
